"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var cors_1 = __importDefault(require("cors"));
var express_1 = __importDefault(require("express"));
var body_parser_1 = __importDefault(require("body-parser"));
var express_request_id_1 = __importDefault(require("express-request-id"));
var http_shutdown_1 = __importDefault(require("http-shutdown"));
var http_1 = __importDefault(require("http"));
var https_1 = __importDefault(require("https"));
var request_router_1 = __importDefault(require("./request-router"));
var default_options_1 = __importDefault(require("./default-options"));
var validate_options_1 = __importDefault(require("./validate-options"));
var validate_routes_1 = __importDefault(require("./validate-routes"));
var types_1 = require("./types");
__export(require("./types"));
var RESTApiService = (function () {
    function RESTApiService(routes, options, expressApp, httpServer) {
        var _this = this;
        this.httpServer = httpServer;
        this.expressApp = expressApp;
        this.port = options.port;
        this.authorizer = options.auth;
        this.verbose = options.verbose;
        this.logErrors = options.logErrors;
        this.log("RESTApiService : Listening at port " + options.port + " (protocol=" + options.protocol + ")");
        expressApp.use(function (req, res, next) {
            _this.log("" + types_1.ConsoleColor.yellow + req.id + " REQUEST  : " + req.method + " " + req.url);
            next();
        });
        request_router_1.default(this, routes);
        this.log("RESTApiService : Ready!");
        this.log("----------------------------------------------------------------");
    }
    RESTApiService.create = function (routes, userOptions) {
        validate_routes_1.default(routes);
        validate_options_1.default(userOptions);
        Object.entries(userOptions).reduce(function (a, _a) {
            var _b;
            var k = _a[0], v = _a[1];
            return (v === undefined ? a : __assign(__assign({}, a), (_b = {}, _b[k] = v, _b)));
        }, {});
        var options = __assign(__assign({}, default_options_1.default), userOptions);
        return new Promise(function (resolve) {
            try {
                var expressApp_1 = express_1.default();
                expressApp_1.use(body_parser_1.default.urlencoded({ extended: false }));
                expressApp_1.use(body_parser_1.default.json());
                expressApp_1.use(express_request_id_1.default());
                expressApp_1.use(cors_1.default(options.cors));
                var _httpServer = void 0;
                if (options.protocol === 'http') {
                    _httpServer = http_1.default.createServer(expressApp_1);
                }
                else {
                    _httpServer = https_1.default.createServer(options.credentials, expressApp_1);
                }
                var httpServer_1 = http_shutdown_1.default(_httpServer);
                expressApp_1.listen(options.port, function () {
                    resolve(new RESTApiService(routes, options, expressApp_1, httpServer_1));
                });
            }
            catch (e) {
                console.error(e);
                throw new Error('Cannot initialize RESTApiService');
            }
        });
    };
    RESTApiService.prototype.destroy = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) {
                        _this.httpServer.forceShutdown(function (error) {
                            if (error)
                                reject(error);
                            else
                                resolve();
                        });
                    })];
            });
        });
    };
    RESTApiService.prototype.log = function () {
        var message = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            message[_i] = arguments[_i];
        }
        if (this.verbose)
            console.log.apply(console, __spreadArrays(message, [types_1.ConsoleColor.reset]));
    };
    RESTApiService.RESTApiServiceError = types_1.RESTApiServiceError;
    return RESTApiService;
}());
exports.default = RESTApiService;
