import { RESTApiServiceError, RESTApiServiceInstance, RESTApiServiceRoute, RESTApiServiceOptions, RESTApiServiceExpressApp, RESTApiServiceRequestAuthorizer } from './';
export * from './types';
export default class RESTApiService implements RESTApiServiceInstance {
    static create(routes: RESTApiServiceRoute[], userOptions: RESTApiServiceOptions): Promise<RESTApiService>;
    private constructor();
    private readonly httpServer;
    readonly expressApp: RESTApiServiceExpressApp;
    readonly authorizer: RESTApiServiceRequestAuthorizer;
    readonly port: number;
    static RESTApiServiceError: typeof RESTApiServiceError;
    logErrors: boolean;
    verbose: boolean;
    destroy(): Promise<void>;
    log(...message: unknown[]): void;
}
